using System;

using Windows.Foundation;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Input;
using Microsoft.UI.Xaml.Media.Animation;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        PointerMoved           += Page_PointerMoved;
        this.closeButton.Click += closeButton_Click;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private
    //////////////////////////////////////////////////////////////////////////////// Event

    #region   ̵ óϱ - Page_PointerMoved(sender, e)

    /// <summary>
    ///   ̵ óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void Page_PointerMoved(object sender, PointerRoutedEventArgs e)
    {
        Point mousePoint = e.GetCurrentPoint(this).Position;

        if(mousePoint.X <= 50)
        {
            ShowLeftPanel();
        }
        else if(this.leftGrid.Opacity == 1 && mousePoint.X > this.leftGrid.ActualWidth)
        {
            HideLeftPanel();
        }
    }

    #endregion
    #region ݱ ư Ŭ óϱ - closeButton_Click(sender, e)

    /// <summary>
    /// ݱ ư Ŭ óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void closeButton_Click(object sender, RoutedEventArgs e)
    {
        HideLeftPanel();
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////// Function

    #region  г ǥϱ - ShowLeftPanel()

    /// <summary>
    ///  г ǥϱ
    /// </summary>
    private void ShowLeftPanel()
    {
        if (this.leftGrid.Visibility == Visibility.Collapsed)
        {
            this.leftGrid.Visibility = Visibility.Visible;

            DoubleAnimation fadeInAnimation = new DoubleAnimation
            {
                Duration = new Duration(TimeSpan.FromMilliseconds(300)),
                From     = 0,
                To       = 1
            };

            Storyboard.SetTarget(fadeInAnimation, this.leftGrid);
            Storyboard.SetTargetProperty(fadeInAnimation, "Opacity");

            Storyboard storyboard = new Storyboard();

            storyboard.Children.Add(fadeInAnimation);

            storyboard.Begin();
        }
    }

    #endregion
    #region  г  - HideLeftPanel()

    /// <summary>
    ///  г 
    /// </summary>
    private void HideLeftPanel()
    {
        if(this.leftGrid.Visibility == Visibility.Visible)
        {
            DoubleAnimation fadeOutAnimation = new DoubleAnimation
            {
                Duration = new Duration(TimeSpan.FromMilliseconds(300)),
                From     = 1,
                To       = 0
            };

            Storyboard.SetTarget(fadeOutAnimation, this.leftGrid);
            Storyboard.SetTargetProperty(fadeOutAnimation, "Opacity");

            Storyboard storyboard = new Storyboard();

            storyboard.Children.Add(fadeOutAnimation);

            storyboard.Completed += (sender, e) => this.leftGrid.Visibility = Visibility.Collapsed;

            storyboard.Begin();
        }
    }

    #endregion
}